using System;
using System.Windows;
using System.Windows.Media;
using System.Windows.Media.Media3D;

namespace TestProject
{
    /// <summary>
    /// ü
    /// </summary>
    public class Sphere : ModelVisualBase
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region Field

        /// <summary>
        /// ̽  Ӽ
        /// </summary>
        public static readonly DependencyProperty SliceCountProperty = DependencyProperty.Register
        (
            "SliceCount",
            typeof(int),
            typeof(Sphere),
            new PropertyMetadata(36, PropertyChangedCallback),
            ValidatePositiveValueCallback
        );

        /// <summary>
        ///   Ӽ
        /// </summary>
        public static readonly DependencyProperty StackCountProperty = DependencyProperty.Register
        (
            "StackCount",
            typeof(int),
            typeof(Sphere),
            new PropertyMetadata(18, PropertyChangedCallback),
            ValidatePositiveValueCallback
        );

        /// <summary>
        /// ߽ Ӽ
        /// </summary>
        public static readonly DependencyProperty CenterPointProperty = DependencyProperty.Register
        (
            "CenterPoint",
            typeof(Point3D),
            typeof(Sphere),
            new PropertyMetadata(new Point3D(0, 0, 0), PropertyChangedCallback)
        );

        /// <summary>
        /// 浵 FROM Ӽ
        /// </summary>
        public static readonly DependencyProperty LongitudeFromProperty = DependencyProperty.Register
        (
            "LongitudeFrom",
            typeof(Double),
            typeof(Sphere),
            new PropertyMetadata(-180.0, PropertyChangedCallback),
            ValidateLongitudeValueCallback
        );

        /// <summary>
        /// 浵 TO Ӽ
        /// </summary>
        public static readonly DependencyProperty LongitudeToProperty = DependencyProperty.Register
        (
            "LongitudeTo",
            typeof(Double),
            typeof(Sphere),
            new PropertyMetadata(180.0, PropertyChangedCallback),
            ValidateLongitudeValueCallback
        );

        /// <summary>
        ///  FROM Ӽ
        /// </summary>
        public static readonly DependencyProperty LatitudeFromProperty = DependencyProperty.Register
        (
            "LatitudeFrom",
            typeof(Double),
            typeof(Sphere),
            new PropertyMetadata(90.0, PropertyChangedCallback),
            ValidateLatitudeValueCallback
        );

        /// <summary>
        ///  TO Ӽ
        /// </summary>
        public static readonly DependencyProperty LatitudeToProperty = DependencyProperty.Register
        (
            "LatitudeTo",
            typeof(Double),
            typeof(Sphere),
            new PropertyMetadata(-90.0, PropertyChangedCallback),
            ValidateLatitudeValueCallback
        );

        /// <summary>
        /// ݰ Ӽ
        /// </summary>
        public static readonly DependencyProperty RadiusProperty = DependencyProperty.Register
        (
            "Radius",
            typeof(double),
            typeof(Sphere),
            new PropertyMetadata(1.0, PropertyChangedCallback),
            ValidateNonNegativeValueCallback
        );

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        ///   ȸ 3D
        /// </summary>
        private AxisAngleRotation3D axisAngleRotation3D;

        /// <summary>
        /// ȸ ȯ 3D
        /// </summary>
        private RotateTransform3D rotateTransform3D;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ̽  - SliceCount

        /// <summary>
        /// ̽ 
        /// </summary>
        public int SliceCount
        {
            get
            {
                return (int)GetValue(SliceCountProperty);
            }
            set
            {
                SetValue(SliceCountProperty, value);
            }
        }

        #endregion
        #region   - StackCount

        /// <summary>
        ///  
        /// </summary>
        public int StackCount
        {
            get
            {
                return (int)GetValue(StackCountProperty);
            }
            set
            {
                SetValue(StackCountProperty, value);
            }
        }

        #endregion
        #region ߽ - CenterPoint

        /// <summary>
        /// ߽
        /// </summary>
        public Point3D CenterPoint
        {
            get
            {
                return (Point3D)GetValue(CenterPointProperty);
            }
            set
            {
                SetValue(CenterPointProperty, value);
            }
        }

        #endregion
        #region 浵 FROM - LongitudeFrom

        /// <summary>
        /// 浵 FROM
        /// </summary>
        public Double LongitudeFrom
        {
            get
            {
                return (Double)GetValue(LongitudeFromProperty);
            }
            set
            {
                SetValue(LongitudeFromProperty, value);
            }
        }

        #endregion
        #region 浵 TO - LongitudeTo

        /// <summary>
        /// 浵 TO
        /// </summary>
        public Double LongitudeTo
        {
            get
            {
                return (Double)GetValue(LongitudeToProperty);
            }
            set
            {
                SetValue(LongitudeFromProperty, value);
            }
        }

        #endregion
        #region  FROM - LatitudeFrom

        /// <summary>
        ///  FROM
        /// </summary>
        public Double LatitudeFrom
        {
            get
            {
                return (Double)GetValue(LatitudeFromProperty);
            }
            set
            {
                SetValue(LatitudeFromProperty, value);
            }
        }

        #endregion
        #region  TO - LatitudeTo

        /// <summary>
        ///  TO
        /// </summary>
        public Double LatitudeTo
        {
            get
            {
                return (Double)GetValue(LatitudeToProperty);
            }
            set
            {
                SetValue(LatitudeToProperty, value);
            }
        }

        #endregion
        #region ݰ - Radius

        /// <summary>
        /// ݰ
        /// </summary>
        public double Radius
        {
            get
            {
                return (double)GetValue(RadiusProperty);
            }
            set
            {
                SetValue(RadiusProperty, value);
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - Sphere()

        /// <summary>
        /// 
        /// </summary>
        public Sphere()
        {
            this.axisAngleRotation3D = new AxisAngleRotation3D();
            this.rotateTransform3D   = new RotateTransform3D(this.axisAngleRotation3D);

            PropertyChangedCallback(this, new DependencyPropertyChangedEventArgs());
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region   Ἲ ݹ óϱ - ValidatePositiveValueCallback(value)

        /// <summary>
        ///   Ἲ ݹ óϱ
        /// </summary>
        /// <param name="value"></param>
        /// <returns>ó </returns>
        private static bool ValidatePositiveValueCallback(object value)
        {
            return (int)value > 0;
        }

        #endregion
        #region    Ἲ ݹ óϱ - ValidateNonNegativeValueCallback(value)

        /// <summary>
        ///    Ἲ ݹ óϱ
        /// </summary>
        /// <param name="value"></param>
        /// <returns>ó </returns>
        private static bool ValidateNonNegativeValueCallback(object value)
        {
            return (double)value >= 0;
        }

        #endregion
        #region 浵  Ἲ ݹ óϱ - ValidateLongitudeValueCallback(value)

        /// <summary>
        /// 浵  Ἲ ݹ óϱ
        /// </summary>
        /// <param name="value"></param>
        /// <returns>ó </returns>
        private static bool ValidateLongitudeValueCallback(object value)
        {
            double d = (double)value;

            return d >= -180 && d <= 180;
        }

        #endregion
        #region   Ἲ ݹ óϱ - ValidateLatitudeValueCallback(value)

        /// <summary>
        ///   Ἲ ݹ óϱ
        /// </summary>
        /// <param name="value"></param>
        /// <returns>ó </returns>
        private static bool ValidateLatitudeValueCallback(object value)
        {
            double d = (double)value;

            return d >= -90 && d <= 90;
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Protected

        #region ﰢ ϱ - Triangulate(e, vertexCollection, normalCollection, indexCollection, textureCollection)

        /// <summary>
        /// ﰢ ϱ
        /// </summary>
        /// <param name="e">̺Ʈ </param>
        /// <param name="vertexCollection"> ÷</param>
        /// <param name="normalCollection"> ÷</param>
        /// <param name="indexCollection">ε ÷</param>
        /// <param name="textureCollection">ؽó ÷</param>
        protected override void Triangulate(DependencyPropertyChangedEventArgs e, Point3DCollection vertexCollection, Vector3DCollection normalCollection, Int32Collection indexCollection, PointCollection textureCollection)
        {
            vertexCollection.Clear();
            normalCollection.Clear();
            indexCollection.Clear();
            textureCollection.Clear();

            int     sliceCount  = SliceCount;
            int     stackCount  = StackCount;
            double  radius      = Radius;
            Point3D centerPoint = CenterPoint;

            double latitude1 = Math.Max(LatitudeFrom, LatitudeTo);
            double latitude2 = Math.Min(LatitudeFrom, LatitudeTo);

            double longitude1 = LongitudeFrom;
            double longitude2 = LongitudeTo;

            for(int latitude = 0; latitude <= stackCount; latitude++)
            {
                double degree = latitude1 - latitude * (latitude1 - latitude2) / stackCount;

                double angle = Math.PI * degree / 180;
                double y     = radius * Math.Sin(angle);
                double scale = Math.Cos(angle);

                for(int longitude = 0; longitude <= sliceCount; longitude++)
                {
                    double difference = longitude2 - longitude1;

                    if(difference < 0)
                    {
                        difference += 360;
                    }

                    degree = longitude1 + longitude * difference / sliceCount;

                    angle = Math.PI * degree / 180;

                    double x = radius * scale * Math.Sin(angle);
                    double z = radius * scale * Math.Cos(angle);

                    Vector3D vector = new Vector3D(x, y, z);

                    vertexCollection.Add(centerPoint + vector);

                    normalCollection.Add(vector);

                    textureCollection.Add
                    (
                        new Point
                        (
                            (double)longitude / sliceCount,
                            (double)latitude  / stackCount
                        )
                    );
                }
            }

            for(int latitude = 0; latitude < stackCount; latitude++)
            {
                int start = latitude * (sliceCount + 1);
                int next  = start + sliceCount + 1;

                for(int longitude = 0; longitude < sliceCount; longitude++)
                {
                    indexCollection.Add(start + longitude    );
                    indexCollection.Add(next  + longitude    );
                    indexCollection.Add(next  + longitude + 1);

                    indexCollection.Add(start + longitude    );
                    indexCollection.Add(next  + longitude + 1);
                    indexCollection.Add(start + longitude + 1);
                }
            }
        }

        #endregion
    }
}