using System;
using System.Windows;
using System.Windows.Media.Animation;
using System.Windows.Media.Media3D;

namespace TestProject
{
    /// <summary>
    /// ī޶ 
    /// </summary>
    public class CameraInfo : Animatable
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        ///  Ʈ Ű
        /// </summary>
        private static readonly DependencyPropertyKey ViewMatrixKey = DependencyProperty.RegisterReadOnly
        (
            "ViewMatrix",
            typeof(Matrix3D),
            typeof(CameraInfo),
            new PropertyMetadata(new Matrix3D())
        );

        /// <summary>
        ///  Ʈ Ű
        /// </summary>
        private static readonly DependencyPropertyKey ProjectionMatrixKey = DependencyProperty.RegisterReadOnly
        (
            "ProjectionMatrix",
            typeof(Matrix3D),
            typeof(CameraInfo),
            new PropertyMetadata(new Matrix3D())
        );

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Public

        #region Field

        /// <summary>
        ///  Ʈ
        /// </summary>
        public static readonly Matrix3D ZeroMatrix = new Matrix3D
        (
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0
        );

        /// <summary>
        /// Ī Ӽ
        /// </summary>
        public static readonly DependencyProperty NameProperty = DependencyProperty.Register
        (
            "Name",
            typeof(string),
            typeof(CameraInfo)
        );

        /// <summary>
        /// ī޶ Ӽ
        /// </summary>
        public static readonly DependencyProperty CameraProperty = DependencyProperty.Register
        (
            "Camera",
            typeof(Camera),
            typeof(CameraInfo),
            new PropertyMetadata(null, CameraPropertyChangedCallback)
        );

        /// <summary>
        /// Ʈ ʺ Ӽ
        /// </summary>
        public static readonly DependencyProperty ViewportWidthProperty = DependencyProperty.Register
        (
            "ViewportWidth",
            typeof(double),
            typeof(CameraInfo),
            new PropertyMetadata(1.0, ViewportPropertyChangedCallback)
        );

        /// <summary>
        /// Ʈ  Ӽ
        /// </summary>
        public static readonly DependencyProperty ViewportHeightProperty = DependencyProperty.Register
        (
            "ViewportHeight",
            typeof(double),
            typeof(CameraInfo),
            new PropertyMetadata(1.0, ViewportPropertyChangedCallback)
        );

        /// <summary>
        ///  Ʈ Ӽ
        /// </summary>
        public static readonly DependencyProperty ViewMatrixProperty = ViewMatrixKey.DependencyProperty;

        /// <summary>
        ///  Ʈ Ӽ
        /// </summary>
        public static readonly DependencyProperty ProjectionMatrixProperty = ProjectionMatrixKey.DependencyProperty;

        /// <summary>
        /// ü ȯ Ӽ
        /// </summary>
        public static readonly DependencyProperty TotalTransformProperty = DependencyProperty.Register
        (
            "TotalTransform",
            typeof(Matrix3D),
            typeof(CameraInfo)
        );

        /// <summary>
        ///  ȯ Ӽ
        /// </summary>
        public static readonly DependencyProperty InverseTransformProperty = DependencyProperty.Register
        (
            "InverseTransform",
            typeof(Matrix3D),
            typeof(CameraInfo)
        );

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Ī - Name

        /// <summary>
        /// Ī
        /// </summary>
        public string Name
        {
            set
            {
                SetValue(NameProperty, value);
            }
            get
            {
                return (string)GetValue(NameProperty);
            }
        }

        #endregion
        #region ī޶ - Camera

        /// <summary>
        /// ī޶
        /// </summary>
        public Camera Camera
        {
            set
            {
                SetValue(CameraProperty, value);
            }
            get
            {
                return (Camera)GetValue(CameraProperty);
            }
        }

        #endregion
        #region Ʈ ʺ - ViewportWidth

        /// <summary>
        /// Ʈ ʺ
        /// </summary>
        public double ViewportWidth
        {
            set
            {
                SetValue(ViewportWidthProperty, value);
            }
            get
            {
                return (double)GetValue(ViewportWidthProperty);
            }
        }

        #endregion
        #region Ʈ  - ViewportHeight

        /// <summary>
        /// Ʈ 
        /// </summary>
        public double ViewportHeight
        {
            set
            {
                SetValue(ViewportHeightProperty, value);
            }
            get
            {
                return (double)GetValue(ViewportHeightProperty);
            }
        }

        #endregion
        #region  Ʈ - ViewMatrix

        /// <summary>
        ///  Ʈ
        /// </summary>
        public Matrix3D ViewMatrix
        {
            private set
            {
                SetValue(ViewMatrixKey, value);
            }
            get
            {
                return (Matrix3D)GetValue(ViewMatrixProperty);
            }
        }

        #endregion
        #region  Ʈ - ProjectionMatrix

        /// <summary>
        ///  Ʈ
        /// </summary>
        public Matrix3D ProjectionMatrix
        {
            private set
            {
                SetValue(ProjectionMatrixKey, value);
            }
            get
            {
                return (Matrix3D)GetValue(ProjectionMatrixProperty);
            }
        }

        #endregion
        #region ü ȯ - TotalTransform

        /// <summary>
        /// ü ȯ
        /// </summary>
        public Matrix3D TotalTransform
        {
            protected set
            {
                SetValue(TotalTransformProperty, value);
            }
            get
            {
                return (Matrix3D)GetValue(TotalTransformProperty);
            }
        }

        #endregion
        #region  ȯ - InverseTransform

        /// <summary>
        ///  ȯ
        /// </summary>
        public Matrix3D InverseTransform
        {
            protected set
            {
                SetValue(InverseTransformProperty, value);
            }
            get
            {
                return (Matrix3D)GetValue(InverseTransformProperty);
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - CameraInfo()

        /// <summary>
        /// 
        /// </summary>
        public CameraInfo()
        {
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region  Ʈ ϱ - GetViewMatrix(camera)

        /// <summary>
        ///  Ʈ ϱ
        /// </summary>
        /// <param name="camera">ī޶</param>
        /// <returns> Ʈ</returns>
        public static Matrix3D GetViewMatrix(Camera camera)
        {
            Matrix3D matrix = Matrix3D.Identity;

            if(camera == null)
            {
                matrix = ZeroMatrix;
            }

            else if(camera is MatrixCamera)
            {
                matrix = (camera as MatrixCamera).ViewMatrix;
            }
            else if(camera is ProjectionCamera)
            {
                ProjectionCamera projectionCamera = camera as ProjectionCamera;

                Vector3D zAxisVector = -projectionCamera.LookDirection;

                zAxisVector.Normalize();

                Vector3D xAxisVector = Vector3D.CrossProduct(projectionCamera.UpDirection, zAxisVector);

                xAxisVector.Normalize();

                Vector3D yAxisVector = Vector3D.CrossProduct(zAxisVector, xAxisVector);

                Vector3D positionVector = (Vector3D)projectionCamera.Position;

                matrix = new Matrix3D
                (
                    xAxisVector.X, yAxisVector.X, zAxisVector.X, 0,
                    xAxisVector.Y, yAxisVector.Y, zAxisVector.Y, 0,
                    xAxisVector.Z, yAxisVector.Z, zAxisVector.Z, 0,
                    -Vector3D.DotProduct(xAxisVector, positionVector),
                    -Vector3D.DotProduct(yAxisVector, positionVector),
                    -Vector3D.DotProduct(zAxisVector, positionVector),
                    1
                );
            }
            else if(camera != null)
            {
                throw new ApplicationException("ViewMatrix");
            }

            return matrix;
        }

        #endregion
        #region  Ʈ ϱ - GetProjectionMatrix(camera, aspectRatio)

        /// <summary>
        ///  Ʈ ϱ
        /// </summary>
        /// <param name="camera">ī޶</param>
        /// <param name="aspectRatio">Ⱦ</param>
        /// <returns> Ʈ</returns>
        public static Matrix3D GetProjectionMatrix(Camera camera, double aspectRatio)
        {
            Matrix3D matrix = Matrix3D.Identity;

            if(camera == null)
            {
                matrix = ZeroMatrix;
            }
            else if(camera is MatrixCamera)
            {
                matrix = (camera as MatrixCamera).ProjectionMatrix;
            }
            else if(camera is OrthographicCamera)
            {
                OrthographicCamera orthographicCamera = camera as OrthographicCamera;

                double xScale = 2 / orthographicCamera.Width;
                double yScale = xScale * aspectRatio;
                double zNear  = orthographicCamera.NearPlaneDistance;
                double zFar   = orthographicCamera.FarPlaneDistance;

                if(Double.IsPositiveInfinity(zFar))
                {
                    zFar = 1E10;
                }

                matrix = new Matrix3D
                (
                    xScale, 0     , 0                     , 0,
                    0     , yScale, 0                     , 0,
                    0     , 0     , 1 / (zNear - zFar)    , 0,
                    0     , 0     , zNear / (zNear - zFar), 1
                );
            }
            else if(camera is PerspectiveCamera)
            {
                PerspectiveCamera perspectiveCamera = camera as PerspectiveCamera;

                double xScale  = 1 / Math.Tan(Math.PI * perspectiveCamera.FieldOfView / 360);
                double yScale  = xScale * aspectRatio;
                double zNear   = perspectiveCamera.NearPlaneDistance;
                double zFar    = perspectiveCamera.FarPlaneDistance;
                double zScale  = (zFar == double.PositiveInfinity ? -1 : (zFar / (zNear - zFar)));
                double zOffset = zNear * zScale;

                matrix = new Matrix3D
                (
                    xScale, 0     , 0      ,  0,
                    0     , yScale, 0      ,  0,
                    0     , 0     , zScale , -1,
                    0     , 0     , zOffset,  0
                );
            }
            else if(camera != null)
            {
                throw new ApplicationException("ProjectionMatrix");
            }
          
            return matrix;
        }

        #endregion
        #region ü ȯ ϱ - GetTotalTransform(camera, aspectRatio)

        /// <summary>
        /// ü ȯ ϱ
        /// </summary>
        /// <param name="camera">ī޶</param>
        /// <param name="aspectRatio">Ⱦ</param>
        /// <returns>ü ȯ</returns>
        public static Matrix3D GetTotalTransform(Camera camera, double aspectRatio)
        {
            Matrix3D matrix = Matrix3D.Identity;

            if(camera == null)
            {
                matrix = ZeroMatrix;
            }
            else
            {
                if(camera.Transform != null)
                {
                    Matrix3D cameraTransformMatrix = camera.Transform.Value;

                    if(!cameraTransformMatrix.HasInverse)
                    {
                        matrix = ZeroMatrix;
                    }
                    else
                    {
                        cameraTransformMatrix.Invert();

                        matrix.Append(cameraTransformMatrix);
                    }
                }

                matrix.Append(CameraInfo.GetViewMatrix(camera));

                matrix.Append(CameraInfo.GetProjectionMatrix(camera, aspectRatio));
            }

            return matrix;
        }

        #endregion
        #region  ȯ ϱ - GetInverseTransform(camera, aspectRatio)

        /// <summary>
        ///  ȯ ϱ
        /// </summary>
        /// <param name="camera">ī޶</param>
        /// <param name="aspectRatio">Ⱦ</param>
        /// <returns> ȯ</returns>
        public static Matrix3D GetInverseTransform(Camera camera, double aspectRatio)
        {
            Matrix3D matrix = GetTotalTransform(camera, aspectRatio);

            if(matrix == ZeroMatrix)
            {
            }
            else if(!matrix.HasInverse)
            {
                matrix = ZeroMatrix;
            }
            else
            {
                matrix.Invert();
            }

            return matrix;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Private

        #region ī޶ Ӽ  ݹ óϱ - CameraPropertyChangedCallback(d, e)

        /// <summary>
        /// ī޶ Ӽ  ݹ óϱ
        /// </summary>
        /// <param name="d"> ü</param>
        /// <param name="e">̺Ʈ </param>
        private static void CameraPropertyChangedCallback(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            CameraInfo cameraInfo = d as CameraInfo;

            cameraInfo.ViewMatrix = GetViewMatrix(cameraInfo.Camera);

            ViewportPropertyChangedCallback(d, e);
        }

        #endregion
        #region Ʈ Ӽ  ݹ óϱ - ViewportPropertyChangedCallback(d, e)

        /// <summary>
        /// Ʈ Ӽ  ݹ óϱ
        /// </summary>
        /// <param name="d"> ü</param>
        /// <param name="e">̺Ʈ </param>
        private static void ViewportPropertyChangedCallback(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            CameraInfo cameraInfo = d as CameraInfo;

            cameraInfo.ViewMatrix = GetViewMatrix(cameraInfo.Camera);

            cameraInfo.ProjectionMatrix = GetProjectionMatrix
            (
                cameraInfo.Camera,
                cameraInfo.ViewportWidth / cameraInfo.ViewportHeight
            );

            cameraInfo.TotalTransform = GetTotalTransform
            (
                cameraInfo.Camera,
                cameraInfo.ViewportWidth / cameraInfo.ViewportHeight
            );

            cameraInfo.InverseTransform = GetInverseTransform
            (
                cameraInfo.Camera,
                cameraInfo.ViewportWidth / cameraInfo.ViewportHeight
            );
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Public

        #region ڿ ϱ - ToString()

        /// <summary>
        /// ڿ ϱ
        /// </summary>
        /// <returns>ڿ</returns>
        public override string ToString()
        {
            return string.Format
            (
                "View Matrix : {0}\nProjection Matrix : {1}\nTotal Transform : {2}",
                ViewMatrix,
                ProjectionMatrix,
                TotalTransform
            );
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Protected

        #region νϽ ϱ (ھ) - CreateInstanceCore()

        /// <summary>
        /// νϽ ϱ (ھ)
        /// </summary>
        /// <returns>Freezable ü</returns>
        protected override Freezable CreateInstanceCore()
        {
            return new CameraInfo();
        }

        #endregion
    }
}