using System.Windows;
using System.Windows.Controls;
using System.Windows.Media.Animation;
using System.Windows.Media.Media3D;

namespace TestProject
{
    /// <summary>
    /// Ʈ 
    /// </summary>
    public class ViewportInfo : Animatable
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// ȯ Ű 
        /// </summary>
        private static readonly DependencyPropertyKey TransformKey = DependencyProperty.RegisterReadOnly
        (
            "Transform",
            typeof(Matrix3D),
            typeof(ViewportInfo),
            new PropertyMetadata(new Matrix3D())
        );

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Public

        #region Field

        /// <summary>
        ///  Ʈ
        /// </summary>
        public static readonly Matrix3D ZeroMatrix = new Matrix3D
        (
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0
        );

        /// <summary>
        /// Ʈ 3D Ӽ
        /// </summary>
        public static readonly DependencyProperty Viewport3DProperty = DependencyProperty.Register
        (
            "Viewport3D",
            typeof(Viewport3D),
            typeof(ViewportInfo),
            new PropertyMetadata(null, Viewport3DPropertyChangedCallback)
        );

        /// <summary>
        /// ȯ Ӽ
        /// </summary>
        public static readonly DependencyProperty TransformProperty = TransformKey.DependencyProperty;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Ʈ 3D - Viewport3D

        /// <summary>
        /// Ʈ 3D
        /// </summary>
        public Viewport3D Viewport3D
        {
            set
            {
                SetValue(Viewport3DProperty, value);
            }
            get
            {
                return (Viewport3D)GetValue(Viewport3DProperty);
            }
        }

        #endregion
        #region ȯ - Transform

        /// <summary>
        /// ȯ
        /// </summary>
        public Matrix3D Transform
        {
            protected set
            {
                SetValue(TransformKey, value);
            }
            get
            {
                return (Matrix3D)GetValue(TransformProperty);
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region ü ȯ ϱ - GetTotalTransform(visual)

        /// <summary>
        /// ü ȯ ϱ
        /// </summary>
        /// <param name="visual">־ ü</param>
        /// <returns>ü ȯ</returns>
        public static Matrix3D GetTotalTransform(Viewport3DVisual visual)
        {
            Matrix3D matrix = GetCameraTransform(visual);

            matrix.Append(GetViewportTransform(visual));

            return matrix;
        }

        #endregion
        #region ü ȯ ϱ - GetTotalTransform(viewport)

        /// <summary>
        /// ü ȯ ϱ
        /// </summary>
        /// <param name="viewport">Ʈ ü</param>
        /// <returns>ü ȯ</returns>
        public static Matrix3D GetTotalTransform(Viewport3D viewport)
        {
            Matrix3D matrix = GetCameraTransform(viewport);

            matrix.Append(GetViewportTransform(viewport));

            return matrix;
        }

        #endregion
        #region ī޶ ȯ ϱ - GetCameraTransform(visual)

        /// <summary>
        /// ī޶ ȯ ϱ
        /// </summary>
        /// <param name="visual">־ ü</param>
        /// <returns>ī޶ ȯ</returns>
        public static Matrix3D GetCameraTransform(Viewport3DVisual visual)
        {
            return CameraInfo.GetTotalTransform
            (
                visual.Camera,
                visual.Viewport.Size.Width / visual.Viewport.Size.Height
            );
        }

        #endregion
        #region ī޶ ȯ ϱ - GetCameraTransform(viewport)

        /// <summary>
        /// ī޶ ȯ ϱ
        /// </summary>
        /// <param name="viewport">Ʈ</param>
        /// <returns>ī޶ ȯ</returns>
        public static Matrix3D GetCameraTransform(Viewport3D viewport)
        {
            return CameraInfo.GetTotalTransform
            (
                viewport.Camera,
                viewport.ActualWidth / viewport.ActualHeight
            );
        }

        #endregion
        #region Ʈ ȯ ϱ - GetViewportTransform(visual)

        /// <summary>
        /// Ʈ ȯ ϱ
        /// </summary>
        /// <param name="visual">־ ü</param>
        /// <returns>Ʈ ȯ</returns>
        public static Matrix3D GetViewportTransform(Viewport3DVisual visual)
        {
            return new Matrix3D
            (
                visual.Viewport.Width / 2, 0                          , 0, 0,
                0                        , -visual.Viewport.Height / 2, 0, 0,
                0                        , 0                          , 1, 0,
                visual.Viewport.X + visual.Viewport.Width  / 2,
                visual.Viewport.Y + visual.Viewport.Height / 2,
                0,
                1
            );
        }

        #endregion
        #region Ʈ ȯ ϱ - GetViewportTransform(viewport)

        /// <summary>
        /// Ʈ ȯ ϱ
        /// </summary>
        /// <param name="viewport">Ʈ</param>
        /// <returns>Ʈ ȯ</returns>
        public static Matrix3D GetViewportTransform(Viewport3D viewport)
        {
            return new Matrix3D
            (
                viewport.ActualWidth / 2,  0                        , 0, 0,
                0                       , -viewport.ActualHeight / 2, 0, 0,
                0                       ,  0                        , 1, 0,
                viewport.ActualWidth / 2,  viewport.ActualHeight / 2, 0, 1
            );
        }

        #endregion
        #region Ʈ 2D ϱ - GetPoint2D(viewport3D, point3D)

        /// <summary>
        /// Ʈ 2D ϱ
        /// </summary>
        /// <param name="viewport3D">Ʈ 3D</param>
        /// <param name="point3D">Ʈ 3D</param>
        /// <returns>Ʈ 2D</returns>
        public static Point GetPoint2D(Viewport3D viewport3D, Point3D point3D)
        {
            Matrix3D matrix = GetTotalTransform(viewport3D);

            Point3D pointTransformed = matrix.Transform(point3D);

            Point point = new Point(pointTransformed.X, pointTransformed.Y);

            return point;
        }

        #endregion
        #region   ϱ - SetLineRange(viewport3D, point2D, lineRange)

        /// <summary>
        ///   ϱ
        /// </summary>
        /// <param name="viewport3D">Ʈ 3D</param>
        /// <param name="point2D">Ʈ 2D</param>
        /// <param name="lineRange"> </param>
        /// <returns>ó </returns>
        public static bool SetLineRange(Viewport3D viewport3D, Point point2D, out LineRange lineRange)
        {
            lineRange = new LineRange();

            Point3D sourcePoint3D = new Point3D(point2D.X, point2D.Y, 0);

            Matrix3D viewportMatrix = GetViewportTransform(viewport3D);

            Matrix3D cameraMatrix = GetCameraTransform(viewport3D);

            if(!viewportMatrix.HasInverse)
            {
                return false;
            }

            if(!cameraMatrix.HasInverse)
            {
                return false;
            }

            viewportMatrix.Invert();

            cameraMatrix.Invert();

            Point3D point3DNormalized = viewportMatrix.Transform(sourcePoint3D);

            point3DNormalized.Z = 0.01;

            Point3D point3DNear = cameraMatrix.Transform(point3DNormalized);

            point3DNormalized.Z = 0.99;

            Point3D point3DFar = cameraMatrix.Transform(point3DNormalized);

            lineRange = new LineRange(point3DNear, point3DFar);

            return true;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Private

        #region Ʈ 3D Ӽ  ݹ óϱ - Viewport3DPropertyChangedCallback(d, e)

        /// <summary>
        /// Ʈ 3D Ӽ  ݹ óϱ
        /// </summary>
        /// <param name="d"> ü</param>
        /// <param name="e">̺Ʈ </param>
        private static void Viewport3DPropertyChangedCallback(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            (d as ViewportInfo).Viewport3DPropertyChanged(e);
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Protected

        #region νϽ ϱ (ھ) - CreateInstanceCore()

        /// <summary>
        /// νϽ ϱ (ھ)
        /// </summary>
        /// <returns>Freezable ü</returns>
        protected override Freezable CreateInstanceCore()
        {
            return new ViewportInfo();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Private

        #region Ʈ 3D Ӽ  óϱ - Viewport3DPropertyChanged(e)

        /// <summary>
        /// Ʈ 3D Ӽ  óϱ
        /// </summary>
        /// <param name="e">̺Ʈ </param>
        private void Viewport3DPropertyChanged(DependencyPropertyChangedEventArgs e)
        {
            if(Viewport3D == null)
            {
                Transform = ZeroMatrix;
            }
            else
            {
                Transform = CameraInfo.GetTotalTransform
                (
                    Viewport3D.Camera,
                    Viewport3D.ActualWidth / Viewport3D.ActualHeight
                );
            }
        }

        #endregion
    }
}