using System;
using System.Windows;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Media.Media3D;

namespace TestProject
{
    /// <summary>
    /// ־ 
    /// </summary>
    public class VisualInfo : Animatable
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// ü ȯ Ű
        /// </summary>
        private static readonly DependencyPropertyKey TotalTransformKey = DependencyProperty.RegisterReadOnly
        (
            "TotalTransform",
            typeof(Matrix3D),
            typeof(VisualInfo),
            new PropertyMetadata(new Matrix3D())
        );

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Public

        #region Field

        /// <summary>
        ///  Ʈ
        /// </summary>
        public static readonly Matrix3D ZeroMatrix = new Matrix3D
        (
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0
        );

        /// <summary>
        ///  ־ 3D Ӽ
        /// </summary>
        public static readonly DependencyProperty ModelVisual3DProperty = DependencyProperty.Register
        (
            "ModelVisual3D",
            typeof(ModelVisual3D),
            typeof(VisualInfo),
            new PropertyMetadata(null, ModelVisual3DPropertyChangedCallback)
        );

        /// <summary>
        /// ü ȯ Ӽ
        /// </summary>
        public static readonly DependencyProperty TotalTransformProperty = TotalTransformKey.DependencyProperty;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  ־ 3D - ModelVisual3D

        /// <summary>
        ///  ־ 3D
        /// </summary>
        public ModelVisual3D ModelVisual3D
        {
            set
            {
                SetValue(ModelVisual3DProperty, value);
            }
            get
            {
                return (ModelVisual3D)GetValue(ModelVisual3DProperty);
            }
        }

        #endregion
        #region ü ȯ - TotalTransform

        /// <summary>
        /// ü ȯ
        /// </summary>
        public Matrix3D TotalTransform
        {
            protected set
            {
                SetValue(TotalTransformKey, value);
            }
            get
            {
                return (Matrix3D)GetValue(TotalTransformProperty);
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region ü ȯ ϱ - GetTotalTransform(dependencyObject)

        /// <summary>
        /// ü ȯ ϱ
        /// </summary>
        /// <param name="dependencyObject"> ü</param>
        /// <returns>ü ȯ</returns>
        public static Matrix3D GetTotalTransform(DependencyObject dependencyObject)
        {
            Matrix3D matrix = Matrix3D.Identity;

            while(!(dependencyObject is Viewport3DVisual))
            {
                if(dependencyObject == null)
                {
                    return ZeroMatrix;
                }

                else if(dependencyObject is ModelVisual3D)
                {
                    if((dependencyObject as ModelVisual3D).Transform != null)
                    {
                        matrix.Append((dependencyObject as ModelVisual3D).Transform.Value);
                    }
                }
                else
                {
                    throw new ApplicationException("didn't end in Viewport3DVisual");
                }

                dependencyObject = VisualTreeHelper.GetParent(dependencyObject);
            }

            Viewport3DVisual visual = dependencyObject as Viewport3DVisual;

            Matrix3D viewportMatrix = ViewportInfo.GetTotalTransform(visual);

            matrix.Append(viewportMatrix);

            return matrix;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Private

        #region  ־ 3D Ӽ  ݹ óϱ - ModelVisual3DPropertyChangedCallback(d, e)

        /// <summary>
        ///  ־ 3D Ӽ  ݹ óϱ
        /// </summary>
        /// <param name="e"> ü</param>
        /// <param name="e">̺Ʈ </param>
        private static void ModelVisual3DPropertyChangedCallback(DependencyObject d,  DependencyPropertyChangedEventArgs e)
        {
            (d as VisualInfo).ModelVisual3DPropertyChanged(e);
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Public

        #region ڿ ϱ - ToString()

        /// <summary>
        /// ڿ ϱ
        /// </summary>
        /// <returns>ڿ</returns>
        public override string ToString()
        {
            return TotalTransform.ToString();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Protected

        #region νϽ ϱ (ھ) - CreateInstanceCore()

        /// <summary>
        /// νϽ ϱ (ھ)
        /// </summary>
        /// <returns>Freezable ü</returns>
        protected override Freezable CreateInstanceCore()
        {
            return new VisualInfo();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Private

        #region  ־ 3D  óϱ - ModelVisual3DPropertyChanged(e)

        /// <summary>
        ///  ־ 3D  óϱ
        /// </summary>
        /// <param name="e">̺Ʈ </param>
        private void ModelVisual3DPropertyChanged(DependencyPropertyChangedEventArgs e)
        {
            TotalTransform = GetTotalTransform(e.NewValue as ModelVisual3D);
        }

        #endregion
    }
}