using System.Windows;
using System.Windows.Media;
using System.Windows.Media.Media3D;

namespace TestProject
{
    /// <summary>
    /// ̾ 
    /// </summary>
    public class WireFrame : WireBase
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region Field

        /// <summary>
        /// ġ ÷ Ӽ
        /// </summary>
        public static readonly DependencyProperty PositionsProperty = MeshGeometry3D.PositionsProperty.AddOwner
        (
            typeof(WireFrame),
            new PropertyMetadata(PropertyChangedCallback)
        );

        /// <summary>
        ///  ÷ Ӽ
        /// </summary>
        public static readonly DependencyProperty NormalsProperty = MeshGeometry3D.NormalsProperty.AddOwner
        (
            typeof(WireFrame),
            new PropertyMetadata(PropertyChangedCallback)
        );

        /// <summary>
        /// ﰢ ε ÷ Ӽ
        /// </summary>
        public static readonly DependencyProperty TriangleIndicesProperty = MeshGeometry3D.TriangleIndicesProperty.AddOwner
        (
            typeof(WireFrame),
            new PropertyMetadata(PropertyChangedCallback)
        );

        /// <summary>
        /// ؽó ǥ ÷
        /// </summary>
        public static readonly DependencyProperty TextureCoordinatesProperty = MeshGeometry3D.TextureCoordinatesProperty.AddOwner
        (
            typeof(WireFrame),
            new PropertyMetadata(PropertyChangedCallback)
        );

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ġ ÷ - Positions

        /// <summary>
        /// ġ ÷
        /// </summary>
        public Point3DCollection Positions
        {
            set
            {
                SetValue(PositionsProperty, value);
            }
            get
            {
                return (Point3DCollection)GetValue(PositionsProperty);
            }
        }

        #endregion
        #region  ÷ - Normals

        /// <summary>
        ///  ÷
        /// </summary>
        public Vector3DCollection Normals
        {
            set
            {
                SetValue(NormalsProperty, value);
            }
            get
            {
                return (Vector3DCollection)GetValue(NormalsProperty);
            }
        }

        #endregion
        #region ﰢ ε ÷ - TriangleIndices

        /// <summary>
        /// ﰢ ε ÷
        /// </summary>
        public Int32Collection TriangleIndices
        {
            set
            {
                SetValue(TriangleIndicesProperty, value);
            }
            get
            {
                return (Int32Collection)GetValue(TriangleIndicesProperty);
            }
        }

        #endregion
        #region ؽó ǥ ÷ - TextureCoordinates

        /// <summary>
        /// ؽó ǥ ÷
        /// </summary>
        public PointCollection TextureCoordinates
        {
            set
            {
                SetValue(TextureCoordinatesProperty, value);
            }
            get
            {
                return (PointCollection)GetValue(TextureCoordinatesProperty);
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region ϱ - Generate(e, lineCollection)

        /// <summary>
        /// ϱ
        /// </summary>
        /// <param name="e">̺Ʈ </param>
        /// <param name="lineCollection"> ÷</param>
        protected override void Generate(DependencyPropertyChangedEventArgs e, Point3DCollection lineCollection)
        {
            Point3DCollection vertexCollection = Positions;

            Int32Collection indexCollection = TriangleIndices;

            lineCollection.Clear();

            if(vertexCollection != null && vertexCollection.Count > 0 && indexCollection != null && indexCollection.Count > 0)
            {
                for(int i = 0; i < indexCollection.Count; i += 3)
                {
                    lineCollection.Add(vertexCollection[indexCollection[i + 0]]);
                    lineCollection.Add(vertexCollection[indexCollection[i + 1]]);

                    lineCollection.Add(vertexCollection[indexCollection[i + 1]]);
                    lineCollection.Add(vertexCollection[indexCollection[i + 2]]);

                    lineCollection.Add(vertexCollection[indexCollection[i + 2]]);
                    lineCollection.Add(vertexCollection[indexCollection[i + 0]]);
                }
            }
        }

        #endregion
    }
}